#!/usr/bin/python
# Fixmultocc - Program for fixing occupancies of multiple conformers
# To be run after CNS 1.0 alternate.inp
# Version 1.0
# Copyright Stephen Graham 2001
# History
#	17/7/01		Initial version (1.0)

import os
import string
import sys

if len(sys.argv) != 4:
	print 'Script for adding correct occupancies to the output of alternate.inp.'
	print 'Copyright 2001 Stephen Graham'
	print 'Usage:	fixmultocc <PDB file> <Mult conf segid prefix (ie AC)> <# of confs>'
	sys.exit(1)

pdbFile = open( sys.argv[1], "rw" )
out = sys.stdout
prefix = sys.argv[2]
occ = 1.00 / string.atoi( sys.argv[3] )

# Output the PDB file again!
out.write( "REMARK Multiple conformation occupancies updated by fixmultocc 1.0\n" )
for ln in pdbFile.readlines():
	if ln[0:4] == "ATOM" and ln[72:72+len(prefix)] == prefix:
		out.write( ln[:56] + "%04.2f"%occ + ln[60:] )
	else: 
		out.write( ln )

# Clean everything up
pdbFile.close()
out.close()

