#!/bin/bash

if ( ! test $1 )
then
  echo "Extract R-factor tables from CNS output"
  echo "Copyright 2001 Stephen Graham"
  echo "Usage: longcnstables <CNS output file>"
  exit 0
fi

for file in $@
do
  if ( ! test -r $file )
  then
    echo "Could not read file $file"
    echo
  fi

  awk '
  /calculate_r/ {
    print ""

    for ( i=0; i<65; i++ )  
      if ( getline <= 0 )
        exit

    while ( !/.*end.*/ )
    {
      print
      if ( getline <= 0 )
        exit
    } }
  ' $file
done
