#!/bin/bash
#
# Cnsinfo - Script for extracting input params from CNS .inp file
# Copyright 2001 Stephen Graham
# Last Modified: 24/7/01
#

if ( ! test $1 )
then
  echo "Extract parameters from CNS input script"
  echo "Copyright 2001 Stephen Graham"
  echo "Usage: cnsinfo <CNS input file>"
  exit 0
fi

for file in $@
do
  if ( ! test -r $file )
  then
    echo "Could not read file $file"
    echo
    continue
  fi

  echo "$file"
  echo "=============================="
  echo

  awk '
  $1 ~ /===>/ {	print
		while ( !/;.*$/ && $NF > 1 )
		{getline; print}  }
  ' $file | sed 's/^{===>}//g'
  echo
done
