#!/bin/bash

if ( ! test $1 )
then
  echo "Extract R-factor tables from CNS output"
  echo "Copyright 2001 Stephen Graham"
  echo "Usage: shortcnstables <CNS output file>"
  exit 0
fi

for file in $@
do

  if ( ! test -r $file )
  then
    echo "Could not read file $file"
    continue
  fi

  # Print the filename
  echo $file

  awk '
  />>>> Overall/ { print }
  />>>> Overall.*working/ { print "" }
  ' $file
done
