#!/usr/bin/perl
#######################
# pmb_make_mp
#######################
$filename=$ARGV[0];
printf "{##############################################################################}\n";    
open(AIN ,"< $filename") or die "cannot open $filename\n";    #Input PDB
printf "{# OPENED input file:  %24s                               #}\n",$filename;    
printf "{##############################################################################}\n";    
open(MPOUTR ,"> $filename-R.mp") or die "cannot open $filename-R.mp\n";    #Output MPdata
printf "{# OPENED output file: %24s-R.mp                          #}\n",$filename;    
printf "{##############################################################################}\n";    
open(MPOUTB ,"> $filename-B.mp") or die "cannot open $filename-B.mp\n";    #Output MPdata
printf "{# OPENED output file: %24s-B.mp                          #}\n",$filename;    
#
#open(MPOUT ,"> /dev/null");      #NOE restraints
#
#######################
#Read Ca Atoms into array
$nnh=0;$na=0;
while (<AIN>){
if($_ =~ "ATOM " && $_ =~ " CA ") {
	if($_!~/ H[ ,A-Z,0-9]/){$nnh++;}
	@line=split(" ",$_);
	#  0      1    2   3   4  5        6      7       8      9     10        11 #
	#ATOM   1920  CA  GLU D  55       7.896 -10.299  22.198  1.00 64.99      D
	$atom_name[$na]=$line[2];$atom_aa[$na]=$line[3];
	#  0      1    2   3      4       5       6      7       8      9        10 #
	#ATOM   1920  CA  GLU    55       7.896 -10.299  22.198  1.00 64.99      D
	if($line[4]=~/[A-Z,a-z]/){$atom_resn[$na]=$line[3];
		$atom_chain[$na]=$line[4];$atom_resid[$na]=$line[5];
		$atom_x[$na]=$line[6];$atom_y[$na]=$line[7];$atom_z[$na]=$line[8];}
	else{$atom_resn[$na]=$line[3];
		$atom_chain[$na]=" ";$atom_resid[$na]=$line[5-1];
		$atom_x[$na]=$line[6-1];$atom_y[$na]=$line[7-1];$atom_z[$na]=$line[8-1];
		}	
	@line=split(" 1.00",$_);$atom_b[$na]=$line[1]/1.00;$avg_b+=$atom_b[$i];
	$na++;
	}};close AIN;
#
$na--;
$avg_b=sqrt($avg_b/$na);
#######################
#Write MATRIX
printf MPOUTR "R %d %d %d %d \n", $atom_resid[0], $atom_resid[$na], $atom_resid[0], $atom_resid[$na];
printf MPOUTB "R %d %d %d %d \n", $atom_resid[0], $atom_resid[$na], $atom_resid[0], $atom_resid[$na];
for($i=0;$i<=$na;$i++){
    printf MPOUTR "B %d %d %s\n", $atom_resid[$i], 0, $atom_resn[$i];
    printf MPOUTB "B %d %d %s\n", $atom_resid[$i], 0, $atom_resn[$i];####if($atom_b[$i]>$avg_b){$avg_b=sqrt($atom_b[$i]);}
    }

#######################
#Write MATRIX
for($i=0;$i<=$na;$i++){
#   for($j=$i;$j<=$na;$j++){
   for($j=0;$j<=$na;$j++){
   	$Rmp=sqrt(($atom_x[$i]-$atom_x[$j])**2 +($atom_y[$i]-$atom_y[$j])**2 +($atom_z[$i]-$atom_z[$j])**2 );
   	$Bmp=($atom_b[$j]-$atom_b[$i])/$avg_b;
#   	$Bmp=20*($atom_resid[$i]-$atom_resid[$na]/2)/$na;
	printf MPOUTR "M %d %d %8.3f\n", $atom_resid[$i], $atom_resid[$j], $Rmp;
	printf MPOUTB "M %d %d %8.3f\n", $atom_resid[$i], $atom_resid[$j], $Bmp;
	}}
close MPOUTR;close MPOUTB;
printf "{##############################################################################}\n";    
printf "{# Wrote %8d matrix elements to output files                             #}\n",$na;    
printf "{##############################################################################}\n";    
#
exit;
### Red->Orange->Yellow->White->Cyan->Blue->Purple ###
printf "
-999  0.50  0.00  0.60
-250  0.50  0.00  0.60
-200  0.00  0.00  1.00
-150  0.40  0.50  1.00
-100  0.30  1.00  0.80
-50   0.70  1.00  1.00
50    1.00  1.00  1.00
100   1.00  1.00  0.70
150   1.00  0.80  0.40
200   1.00  0.40  0.30
250   1.00  0.00  0.00
999   0.60  0.00  0.00
9999  0.00  0.00  0.00
### Red->Orange->Yellow->White->Cyan->Blue->Purple ###2
-2.50  0.30  0.00  0.70
-2.00  0.00  0.30  1.00
-1.50  0.20  0.60  1.00
-1.00  0.30  1.00  0.80
-0.50  0.80  1.00  1.00
 0.50  1.00  1.00  1.00
 1.00  1.00  1.00  0.70
 1.50  1.00  0.80  0.40
 2.00  1.00  0.40  0.30
 2.50  1.00  0.00  0.00
  999  0.60  0.00  0.00
 9999  0.00  0.00  0.00
";
#########################################################
printf "
### Purple-blue-green-yellow-orange-red-white ###
  -8  0.10  0.00  0.40 
  -6  0.30  0.00  0.55 
  -5  0.30  0.00  0.80
  -4  0.00  0.00  1.00 
  -3  0.00  0.50  0.90 
  -2  0.00  0.80  0.50 
  -1  0.00  0.90  0.30 
   1  0.10  1.00  0.10 
   2  0.55  0.95  0.00 
   3  0.80  0.70  0.00 
   4  1.00  0.60  0.00 
   5  1.00  0.50  0.20 
   6  1.00  0.20  0.20 
   8  1.00  1.00  0.30 
 999  1.00  1.00  0.80 
9999  0.00  0.00  0.00 
";
#########################################################
