      PROGRAM PMB_CNS2PHS
C      LOCAL SCALE PROGRAM USING BOX 5 X 5 X 5
C      
C       TOM HYNES 8/17/87
c      Modified: 8/90 (Mike Sintchak)
c      Modified: 5/7/97 (Mark A. White)to read XPLOR 'Fobs Sigma Fcalc'
c                  for any lattice type. Automatic index limits.
c      Modified: 5/8/97 (Mark A. White)to ouput *.phs files'
c      Modified: 611/97 (Mark A. White)to include Fo=0.0'
c      Modified: 7/9/01 (Mark A. White)to include phases in CV'
C            VERSION 5 - December 14, 1998
C            VERSION 8 - January 15, 2002 fix PHI 0-360 deg
C            VERSION 8R - July 8, 2003**REJECT**I/s>20
C            VERSION 10 - Oct. 30, 2003 BOX size scales with axis length
c      f77 pmb_cns2phs_v12.for -o pmb_cns2phs_v12.I65
c      g77 pmb_cns2phs_v12.for -o pmb_cns2phs_v12.i386
C----------------------------------------------------------------------
C       PROGRAM CALCULATES A LOCAL SCALE FACTOR FOR EACH REFLECTION.
C       SUM(FC)/SUM(FO) SCALE FACTOR FOR REFLECTIONS IN A 5 X 5 X 5 BOX 
C       AROUND EACH REFLECTION CALCULATED AND APPLIED TO 'FO'.
C       SCALE CALCULATION EXCLUDES THE REFLECTION BEING CORRECTED
C       TO AVOID BIAS.
C
C       REFLECTIONS WITH LESS THAN 'NBAD' REFLECTIONS IN BOX ARE SCALED
C       AND WRITTEN TO A SECOND FILE.
C
C----------------------------------------------------------------------
        DATA      NBAD/30/
        DATA      DTR/0.017453293/
        DATA      IU_H/115/,IU_K/ 79/,IU_L/125/
        DATA      IL_H/-40/,IL_K/-55/,IL_L/  0/,IN_REF/9000000/
C EDIT limits here: use search and replace to change all <==###########LIMITS
C   -40:115            -55:79            0:125                                     <==###########LIMITS
c
c      -- take Fo,Fc and Fb from the same file (output from CNS)
c      -- can vary size of box from 5x5x5
c      -- use distance weighting scheme (parabolic)
c  
        CHARACTER*60 INFILE,OUTFILE,BADFILE,PHSOUTFILE1,PHSOUTFILE2
        character*10 j1,j2,j3
        character*80 line,j4
            REAL*4 FCSUM,FOSUM,SIGCOR,HISCALE,LOSCALE,
     1  F1,PHI,SIG1,FC,PhiC,FORAW,JUNK,
     2  FB,PhiB, H00s(15), OK0s(15), OOLs(15),
     3  HKLs(15),HK0s(15),H0Ls(15),OKLs(15),AVGSCALE,
     4  FOSS,FSD,FOLSS, FLSD, FOSSW,FSDW
     5  FOLSS2S, FLSD2S, FOSS2S,FSD2S, FOLSSW, FLSDW
        INTEGER*2  H,K,L,MH,MK,ML,TEST
        INTEGER*4  COUNT,CT1,CT2,CT3, HKct(15),HLct(15),KLct(15)
        INTEGER*4  Hct(15) , Kct(15), Lct(15),HKLct(15),I
        INTEGER*2  imin_H,imin_K, imin_L, maxsclct
        INTEGER*2  imax_H,imax_K, imax_L, Sclct(20)
        DIMENSION   SIGMAT(-40:115,-55:79,0:125)
        DIMENSION   FCMAT(-40:115,-55:79,0:125)
        DIMENSION   F1MAT(-40:115,-55:79,0:125)
        DIMENSION   PHIMAT(-40:115,-55:79,0:125)
        DIMENSION   ITESTMAT(-40:115,-55:79,0:125)
        DIMENSION   SCALEMAT(-40:115,-55:79,0:125)
C      DIMENSION   SIMAT(-40:115,-55:79,0:125)
C
      print *,'      Protein Model Builder '
      print *,'      CNS 2 PHS  v.1.2 '
      print *,' '
      print *,' (c) 2004,2003,2002,2001,2000,1999,1998 
     1Mark A White, SCSB, UTMB '
      print *,'  Based on work by Tom Hynes & Mike Sintchak (Yale)'
      print *,'  Based on Czerwinski & Mathews'
      print *,' '
      print *,' This program will read a CNS reflection file'
      print *,' which contains Fo Fc Fb and Phi and Test. The output is'
      print *,' a CNS format reflection file with scaled Fo Phi & Test'
      print *,' Matrix limits are (h,k,l)=(-40:115,-55:79,0:125)'
c
c -- get file name information, open appropriate files
c
      print 800, 'CNS input file with Fo sFo Fc Fb Phi:> '
      read 900, infile

      print 800, 'output file with scaled Fs:> '
      read 900, outfile

      print 911, 'output file with N<',NBAD,' Fs:> '
      read 900, badfile

      print 800, 'minimium box extent (e.g., (+/-) 3 => (7x7x7)-1=  '
      print 800, '342 reflections.  Box size is scaled for longer axes'
      print 800, 'minimium box extent: '
      read 820, ibox
      if (ibox.lt.1) ibox = 3
      if (ibox.gt.15) ibox = 3

      print 800, 'Reject if F/sigma(F) > (5 - 999): '
      read 820, iosigma
      if (iosigma.lt.5) iosigma = 5
      if (iosigma.gt.999) iosigma = 999

      print 800, 'Xtalview output file with local scaled Fs:> '
      read 900, phsoutfile1
      print 800, 'Xtalview output file with scaled Fs:> '
      read 900, phsoutfile2
C
      print *,'This program will also create the following files:'
      print *,'lscale.phs: An XtalView PHS file with locally scaled 
     1 Fo Fc Phi'
      print *,'Fobs.phs: An XtalView PHS file with scaled Fo Fc Phi'
      OPEN (1,NAME=INFILE, TYPE='OLD',form='formatted')
      OPEN (2,NAME=OUTFILE, TYPE='unknown',FORM='FORMATTED')
      OPEN (8,NAME=BADFILE, TYPE='unknown',FORM='FORMATTED')
      open (3,NAME=PHSOUTFILE1,type='unknown',form='formatted')
      open (4,NAME=PHSOUTFILE2,type='unknown',form='formatted')
C
      print *, 'Setting up arrays ...'
C
C FILL FO AND FC ARRAYS WITH ZEROS
C
c        DO 128 H=imin_H,imax_H
c          DO 129 K=imin_K,imax_K
c            DO 130 L=imin_L,imax_L
        DO 128 H=IL_H,IU_H
          DO 129 K=IL_K,IU_K
            DO 130 L=IL_L,IU_L
C
              F1MAT(H,K,L) = -9999.0
              SIGMAT(H,K,L)  = 0.0
              FCMAT(H,K,L)   = 0.0
              PHIMAT(H,K,L)  = 0.0
              SCALEMAT(H,K,L)= 0.0
              ITESTMAT(H,K,L)= 0.0
C
130         CONTINUE
129       CONTINUE
128     CONTINUE   
        CT1 = 0
        CT2 = 0
        CT3 = 0
        HISCALE = 0.0
        LOSCALE = 10.00
      imin_H = 10
      imin_K = 10
      imin_L = 10
      imax_H = 0
      imax_K = 0
      imax_L = 0
      DO 132 i=1,10
          Hct(i)=0
          Kct(i)=0
          Lct(i)=0
          HKct(i)=0
          HLct(i)=0
          KLct(i)=0
          HKLct(i)=0
          H00s(i)=0.0
          OK0s(i)=0.0
          OOLs(i)=0.0
          HK0s(i)=0.0
          H0Ls(i)=0.0
          OKLs(i)=0.0
          HKLs(i)=0.0
132      continue
C
C  READ VALUES INTO ARRAYS ======================
C
      print *, 'reading reflections file ...'
        DO 205 I=1,IN_REF
c
c -- get all lines starting with 'INDE', toss out the rest
        read(1,900,end=210) line
        if (line(2:5).eq.'INDE') then
                read(line,810) j1,H,K,L,j2,F1,PHI,j3,SIG1,j4,TEST
                read(1,811) j4, Fc, PhiC, j2, FB, PhiB
                read(1,812) j4, j, j2, j
CNS_0.5                read(1,813) j4, junk, j2, junk
                CT3 = CT3 + 1
C             Short form reflections = fobs fcalc
c                read(line,810) j1, H, K, L, j2, F1, junk, j4, Fc, PHI
C             Long form reflections = fobs sigma fcalc { 2 lines }
C----------------------------------------------------------------------
C - Caculate the combined phase and and total Fcalc = Fmodel + Fsolvent
C
            FCSUM= sqrt( (FC*cos(PhiC*DTR)+FB*cos(PhiB*DTR))**2 +
     1            (FC*sin(PhiC*DTR)+FB*sin(PhiB*DTR))**2)
            FOSUM=FC*cos(PhiC*DTR)+FB*cos(PhiB*DTR)
            FORAW=FC*sin(PhiC*DTR)+FB*sin(PhiB*DTR)
            if(FOSUM.gt.0.0)then
                  if(FOSUM.gt.0.00001) then
                      PHI= atan(FORAW/FOSUM)/DTR
                        if(PHI.lt.0)  PHI=PHI+360
                  else
                    if(FORAW.gt.0.0) then
                          PHI=90.0
                    else
                        PHI=270.0
                    endif
                  endif
            else
                  if(FOSUM.lt.-0.00001) then
                      PHI= 180 + atan(FORAW/FOSUM)/DTR
                        if(PHI.lt.0) PHI=PHI+360
                  else
                    if(FORAW.gt.0.0) then
                          PHI=90.0
                    else
                        PHI=270.0
                    endif
                  endif
            endif
C
                if (CT3.le.20) then
                print *, H,K,L,F1,FCSUM,'=',FC,'+',FB
                    print 250, H, K, L, F1, SIG1, TEST
            endif
            FC=FCSUM
C
C                WRITE(4,255) H,K,L,F1,FC,PHI
C                                                       <==###########LIMITS
       if (H.ge.IL_H.and.K.ge.IL_K.and.L.ge.IL_L.and.
     1     H.le.IU_H.and.K.le.IU_K.and.L.le.IU_L) then
                if (CT3.le.20) then
                  print *, h,k,l,f1,fc
                  endif
                F1MAT(H,K,L) = F1
                FCMAT(H,K,L) = FC
                SIGMAT(H,K,L)= SIG1
                ITESTMAT(H,K,L)= TEST
                PHIMAT(H,K,L)= PHI
                imin_H = MIN(imin_H,H)
                imin_K = MIN(imin_K,K)
                imin_L = MIN(imin_L,L)
                imax_H = MAX(imax_H,H)
                imax_K = MAX(imax_K,K)
                imax_L = MAX(imax_L,L)
                endif
        endif

205     CONTINUE
210     CONTINUE
      print 910, 'reflections read:', CT3
C
C ----------------------- CNS *.cv Header -----------------------
C
      WRITE(2, 260) CT3
      WRITE(2, 261)
      WRITE(2, 262)
      WRITE(2, 263)
      WRITE(2, 264)

C  ====================== ====== LOCAL SCALING ==== ======================
C  LOOP THROUGH EACH H K L VALUE, IF FO VALUE .NE. 0.0 THEN SUM FO's
C  AND FC's IN BOX, CALCULATE AND APPLY SCALE AND WRITE OUT CORRECTED
C  VALUES.
C
C FILL SCALEMAT ARRAY WITH ZEROS
C
        DO 220 H=imin_H,imax_H
          DO 221 K=imin_K,imax_K
            DO 222 L=imin_L,imax_L
               SCALEMAT(H,K,L)= 0.0
222         CONTINUE
221       CONTINUE
220     CONTINUE  
      FOLSS=0
	  FOLSD=0
	  FOLS2S=0
	  FLSD2S=0
	  FOLSSW=0
      FLSDW=0
c
c -- determine ecentricity of the box  -- MAW -- Oct 2003
c
            ishort = MAX(imax_H, -imin_H)
            ishort  = MIN(ishort, MAX(imax_K, -imin_K))
            ishort  = MIN(ishort, MAX(imax_L, -imin_L))
            ihbox = ibox * MAX(imax_H, -imin_H)/ishort
            ikbox = ibox * MAX(imax_K, -imin_K)/ishort
            ilbox = ibox * MAX(imax_L, -imin_L)/ishort
C
C
      print *,'performing local scaling ...'
      print *,' Matrix limits are (h,k,l) = (-40:115,-55:79,0:125)'
      print *,' (h,k,l) box sizes = +/-', ihbox, ikbox, ilbox
      DO 500 H = imin_H,imax_H
        print *,' ... H = ', H,' min=',imin_H,' max=',imax_H
        DO 600 K = imin_K,imax_K
           DO 700 L = imin_L,imax_L
C
             FORAW = F1MAT(H,K,L)
             IF (FORAW.LT. 0.0 .or. SIGMAT(H,K,L).EQ. 0.0) GO TO 700
C                 
             FCSUM = 0.0            ! old scaling
             FOSUM = 0.0
             COUNT = 0
c
c -- determine extent (indices) of the box
c
             ihstart = H - ihbox
             ikstart = K - ikbox
             ilstart = L - ilbox

             ihstop = H + ihbox
             ikstop = K + ikbox
             ilstop = L + ilbox

c -- shift box if extent .le. 0 to include more refs
CMAW-- Check if start < imin
             if (ihstart .le. imin_H) then
                ihstart = imin_H
                ihstop = imin_H+ihbox + 1
                endif
             if (ikstart .le. imin_K) then
                ikstart = imin_K
                ikstop = imin_K+ikbox + 1
                endif
             if (ilstart .le. imin_L) then
                ilstart = imin_L
                ilstop = imin_L+ilbox + 1
                endif
CMAW-- Check if istop > imax
             if (ihstop .gt. imax_H) then
                ihstop = imax_H
                ihstart = imax_H-ihbox - 1
                endif
             if (ikstop .gt. imax_K) then
                ikstop = imax_K
                ikstart = imax_K-ikbox - 1
                endif
             if (ilstop .gt. imax_L) then
                ilstop = imax_L
                ilstart = imax_L-ilbox - 1
                endif

c
C  SUM VALUES IN BOX ======================
C
              DO 75 MH = ihstart, ihstop
                 DO 65 MK = ikstart, ikstop
                    DO 55 ML = ilstart, ilstop
C
                       IF (F1MAT(MH,MK,ML) .GT. 0.0) THEN
                          FOSUM = FOSUM + F1MAT(MH,MK,ML)
                          FCSUM = FCSUM + FCMAT(MH,MK,ML)
                          COUNT = COUNT + 1  
                          END IF
C
55                  CONTINUE
65               CONTINUE
75            CONTINUE
C
C  APPLY SCALE TO FO & SIG1 ======================
c
c -- scale2 and focor2 are calc. using distance weighting
c
                  SCALE = (FCSUM-FCMAT(H,K,L))/(FOSUM-FORAW)
                  FOCOR = SCALE * FORAW
                  SIGCOR= SCALE * SIGMAT(H,K,L)
CMAW **REJECT****REJECT****REJECT****REJECT****REJECT****REJECT****REJECT** 
CMAW --**REJECT**if F/s(f)> iosigma && Fobs !=0
CMAW **REJECT****REJECT****REJECT****REJECT****REJECT****REJECT****REJECT** 
CMAW        FSIGMA =SQRT(((FOCOR - FCMAT(H,K,L))**2) /(FCMAT(H,K,L) + 1.0))
        FSIGMA = (FOCOR - FCMAT(H,K,L)) / SQRT(FCMAT(H,K,L) + 1.0)
            if (FSIGMA.gt.iosigma) then
            print 930, H,K,L,FOCOR,FCMAT(H,K,L),
     1      FSIGMA,ITESTMAT(H,K,L)
            goto 700
            endif
930   FORMAT('REJECT reflection:',3I4,2f8.2,f6.0,' Test=',I3)
c
c -- max and min scaling + Statistics  based on older method
c
      IF (COUNT .GT. NBAD) THEN
             HISCALE = MAX(HISCALE,SCALE)
             LOSCALE = MIN(LOSCALE,SCALE)
             SCALEMAT(H,K,L)=SCALE
             if (H.eq.0.and.K.eq.0) then
               i = 1+ abs(L)*9/max(imax_L,abs(imin_L))
               OOLs(i)= OOLs(i) + SCALE
               Lct(i) = Lct(i) +1
             endif
             if (H.eq.0.and.L.eq.0) then
               i = 1+ abs(K)*9/max(imax_K,abs(imin_K))
               OK0s(i)= OK0s(i) + SCALE
               Kct(i) = Kct(i) +1
             endif
             if (K.eq.0.and.L.eq.0) then
               i = 1+ abs(H)*9/max(imax_H,abs(imin_H))
               H00s(i)= H00s(i) + SCALE
               Hct(i) = Hct(i) +1
             endif
             if (L.eq.0.and.abs(K).eq.abs(H)) then
               i = 1+ abs(H*1.3)*9/max(imax_H,abs(imin_H))
               HK0s(i)= HK0s(i) + SCALE
               HKct(i) = HKct(i) +1
             endif
             if (K.eq.0.and.abs(H).eq.abs(L)) then
               i = 1+ abs(H*1.3)*9/max(imax_H,abs(imin_H))
               H0Ls(i)= H0Ls(i) + SCALE
               HLct(i) = HLct(i) +1
             endif
             if (H.eq.0.and.abs(K).eq.abs(L)) then
               i = 1+ abs(K*1.3)*9/max(imax_K,abs(imin_K))
               OKLs(i)= OKLs(i) + SCALE
               KLct(i) = KLct(i) +1
             endif
             AVGSCALE=AVGSCALE+(SCALE/CT3) 
c
c ---------------- WRITE *.cv and lscale.phs files -------------------
C
             IF ( FCMAT(H,K,L) .GT.0.0009.or.SIGCOR.gt.0.0009 ) then
C        WRITE(2,250) H,K,L,FOCOR,SIGCOR,ITESTMAT(H,K,L)                
        WRITE(2,251) H,K,L,FOCOR,PHIMAT(H,K,L),SIGCOR,ITESTMAT(H,K,L)                
        WRITE(3,255) H,K,L,FOCOR,FCMAT(H,K,L),PHIMAT(H,K,L) 
              endif
C
              FOLSS=FOLSS+FOCOR
              FLSD=FLSD+abs(FOCOR-FCMAT(H,K,L))
              if(SIGCOR.gt.0.0) then
                 FOLSSW=FOLSSW+FOCOR/SIGCOR
                 FLSDW=FLSDW+abs(FOCOR-FCMAT(H,K,L))
     1                 /SIGCOR
              endif
              if (FOCOR.gt. 2*SIGCOR)  then
                 FOLSS2S=FOLSS2S+FOCOR
                 FLSD2S=FLSD2S+abs(FOCOR-FCMAT(H,K,L))
               endif
               CT1 = CT1 + 1
C
               ELSE 
C - BAD
               WRITE(8,250) H, K, L, FOCOR, SIGCOR, ITESTMAT(H,K,L)
               CT2 = CT2 + 1
C
               ENDIF
C ----------------endif COUNT > NBAD -------------------------------
700         CONTINUE
600       CONTINUE
500     CONTINUE
C
      CLOSE(UNIT = 1)
      CLOSE(UNIT = 2)
      CLOSE(UNIT = 3)
      CLOSE(UNIT = 8)
C
C ====================== ====================== ======================
      print *, ' '
      print 910, 'reflections read:', CT3
      print *  , 'H range (',IL_H,':',IU_H,')',imin_H,' to ',imax_H
      print *  , 'K range (-55:79)',imin_K,' to ',imax_K
      print *  , 'L range (0:125)',imin_L,' to ',imax_L
      print 911, 'reflections written (N > ',NBAD,'):', CT1
      print 911, 'reflections written (N < ',NBAD,'):', CT2
CMAW      print *  , ' Box size (h,k,l) +/-:', ibox
      print 912,' (h,k,l) box sizes = +/-', ihbox, ikbox, ilbox
      print 920, 'maximum scale used (localscale method):',hiscale
      print 920, 'minimum scale used (localscale method):',loscale
      print 920, 'average scale used  (avg scale method):',AVGSCALE
      print *,'Scaled Fobs written to file (average scale method): ',
	1  outfile
      print *, ' '
C
      do 750 i= 1,10
            if (Hct(i).gt.0) then 
                  H00s(i)=100*H00s(i)/Hct(i)/AVGSCALE
            else 
                  H00s(i) = 0
            endif
            if (Kct(i).gt.0) then 
                  OK0s(i)=100*OK0s(i)/Kct(i)/AVGSCALE
            else 
                  OK0s(i) = 0
            endif
            if (Lct(i).gt.0) then 
                  OOLs(i)=100*OOLs(i)/Lct(i)/AVGSCALE
            else 
                  OOLs(i) = 0
            endif
            if (HKct(i).gt.0) then 
                  HK0s(i)=100*HK0s(i)/HKct(i)/AVGSCALE
            else 
                  HK0s(i) = 0
            endif
            if (HLct(i).ge.1) then 
                  H0Ls(i)=100*H0Ls(i)/HLct(i)/AVGSCALE
            endif
            if (KLct(i).ge.1) then 
                  OKLs(i)=100*OKLs(i)/KLct(i)/AVGSCALE
            endif
750      continue
C
      print *,'Average Percentage Scale Factors by Shell:',AVGSCALE
      print *,'shell    H 0 0    0 K 0    0 0 L    H K 0    H 0 L',
     1'    0 K L '
C
      do 752 i= 1,10
      print 753,i,H00s(i),OK0s(i),OOLs(i),HK0s(i),H0Ls(i),OKLs(i)
752      continue
753    FORMAT(1x,i5,6f9.1)      
      print *, ' '
C
C Print Histogram of Scale factors
C
      maxsclct=0
      FOSUM=0
      FCSUM=0
	  FOSS=0
	  FSD=0
	  FOSSW=0
	  FSDW=0
	  FOSS2S=0
	  FSD2S=0
	  DO 755 i=1,20
	    Sclct(i)=0
755   continue
      print *, 'Scale Factor Histogram ...Low to High'
        DO 1000 H = imin_H,imax_H
           DO 1001 K = imin_K,imax_K
              DO 1002 L = imin_L,imax_L
            if( SCALEMAT(H,K,L).gt. 0.001) then
              i=(1.0+(19.0*(SCALEMAT(H,K,L)-loscale))/(hiscale-loscale))
              Sclct(i)=Sclct(i)+1
              if(Sclct(i).gt.maxsclct) maxsclct=Sclct(i) 
              endif
C -------------- WRITE Fobs.phs ---------------------------------
            if(FCMAT(H,K,L).gt.0.0009.or.SIGMAT(H,K,L).gt.0.0009) then
              WRITE(4,255) H,K,L,AVGSCALE*F1MAT(H,K,L),
     1                  FCMAT(H,K,L),PHIMAT(H,K,L)
              FOSS=FOSS+F1MAT(H,K,L)*AVGSCALE
              FSD=FSD+abs(F1MAT(H,K,L)*AVGSCALE-FCMAT(H,K,L))
              if(SIGMAT(H,K,L).gt.0.0) then
               FOSSW=FOSSW+F1MAT(H,K,L)/SIGMAT(H,K,L)
               FSDW=FSDW+abs(F1MAT(H,K,L)-FCMAT(H,K,L)/
     1                            AVGSCALE)/SIGMAT(H,K,L)
               if (F1MAT(H,K,L) .gt. 2.0*SIGMAT(H,K,L)) then
                FOSS2S=FOSS2S+F1MAT(H,K,L)*AVGSCALE
                FSD2S=FSD2S+abs(F1MAT(H,K,L)*AVGSCALE-FCMAT(H,K,L))
                endif
               endif
             endif
c
1002            CONTINUE
1001         CONTINUE
1000      CONTINUE
      CLOSE(UNIT = 4)
      DO 1300 i=1 , 20
      Sclct(i)=(41*Sclct(i))/maxsclct
      if(Sclct(i).gt.40.0) then
            print*, i,':******************************************'
            GOTO 1300
      endif
      if(Sclct(i).gt.39.0) then
            print*, i,':*****************************************'
            GOTO 1300
      endif
      if(Sclct(i).gt.38.0) then
            print*, i,':****************************************'
            GOTO 1300
      endif
      if(Sclct(i).gt.37.0) then
            print*, i,':***************************************'
            GOTO 1300
      endif
      if(Sclct(i).gt.36.0) then
            print*, i,':**************************************'
            GOTO 1300
      endif
      if(Sclct(i).gt.35.0) then
            print*, i,':*************************************'
            GOTO 1300
      endif
      if(Sclct(i).gt.34.0) then
            print*, i,':************************************'
            GOTO 1300
      endif
      if(Sclct(i).gt.33.0) then
            print*, i,':***********************************'
            GOTO 1300
      endif
      if(Sclct(i).gt.32.0) then
            print*, i,':**********************************'
            GOTO 1300
      endif
      if(Sclct(i).gt.31.0) then
            print*, i,':*********************************'
            GOTO 1300
      endif
      if(Sclct(i).gt.30.0) then
            print*, i,':********************************'
            GOTO 1300
      endif
      if(Sclct(i).gt.29.0) then
            print*, i,':*******************************'
            GOTO 1300
      endif
      if(Sclct(i).gt.28.0) then
            print*, i,':******************************'
            GOTO 1300
      endif
      if(Sclct(i).gt.27.0) then
            print*, i,':*****************************'
            GOTO 1300
      endif
      if(Sclct(i).gt.26.0) then
            print*, i,':****************************'
            GOTO 1300
      endif
      if(Sclct(i).gt.25.0) then
            print*, i,':***************************'
            GOTO 1300
      endif
      if(Sclct(i).gt.24.0) then
            print*, i,':**************************'
            GOTO 1300
      endif
      if(Sclct(i).gt.23.0) then
            print*, i,':*************************'
            GOTO 1300
      endif
      if(Sclct(i).gt.22.0) then
            print*, i,':************************'
            GOTO 1300
      endif
      if(Sclct(i).gt.21.0) then
            print*, i,':***********************'
            GOTO 1300
      endif
      if(Sclct(i).gt.20.0) then
            print*, i,':**********************'
            GOTO 1300
      endif
      if(Sclct(i).gt.19.0) then
            print*, i,':*********************'
            GOTO 1300
      endif
      if(Sclct(i).gt.18.0) then
            print*, i,':********************'
            GOTO 1300
      endif
      if(Sclct(i).gt.17.0) then
            print*, i,':*******************'
            GOTO 1300
      endif
      if(Sclct(i).gt.16.0) then
            print*, i,':*****************'
            GOTO 1300
      endif
      if(Sclct(i).gt.15.0) then
            print*, i,':****************'
            GOTO 1300
      endif
      if(Sclct(i).gt.14.0) then
            print*, i,':***************'
            GOTO 1300
      endif
      if(Sclct(i).gt.13.0) then
            print*, i,':**************'
            GOTO 1300
      endif
      if(Sclct(i).gt.12.0) then
            print*, i,':*************'
            GOTO 1300
      endif
      if(Sclct(i).gt.11.0) then
            print*, i,':************'
            GOTO 1300
      endif
      if(Sclct(i).gt.10.0) then
            print*, i,':***********'
            GOTO 1300
      endif
      if(Sclct(i).gt.9.0) then
            print*, i,':**********'
            GOTO 1300
      endif
      if(Sclct(i).gt.8.0) then
            print*, i,':*********'
            GOTO 1300
      endif
      if(Sclct(i).gt.7.0) then
            print*, i,':********'
            GOTO 1300
      endif
      if(Sclct(i).gt.6.0) then
            print*, i,':*******'
            GOTO 1300
      endif
      if(Sclct(i).gt.5.0) then
            print*, i,':******'
            GOTO 1300
      endif
      if(Sclct(i).gt.4.0) then
            print*, i,':*****'
            GOTO 1300
      endif
      if(Sclct(i).gt.3.0) then
            print*, i,':****'
            GOTO 1300
      endif
      if(Sclct(i).gt.2.0) then
            print*, i,':***'
            GOTO 1300
      endif
      if(Sclct(i).gt.1.0) then
            print*, i,':**'
            GOTO 1300
      endif
      if(Sclct(i).gt.0.001) then
            print*, i,':*'
            GOTO 1300
      else
            print*, i,':'
      endif
1300      CONTINUE
      print *, 'R-factor before & after local scaling'
      print 1301, FSD/FOSS*100, FLSD/FOLSS*100
1301   FORMAT(' R(Fobs)   =', f8.3,'    R(lscale)    =', f8.3 )
      print 1302, FSD2S/FOSS2S*100, FLSD2S/FOLSS2S*100
1302   FORMAT(' R(Fobs>2s)=', f8.3,'    R(lscale>2s) =', f8.3 )
      print 1303, FSDW/FOSSW*100, FLSDW/FOLSSW*100
1303   FORMAT(' Rw(Fobs)  =', f8.3,'    Rw(lscale)   =', f8.3 )
C ====================== ====================== ======================
800   FORMAT(1x,a,$)
C   XPLOR Fo Fc file   FORMAT
C810   FORMAT(a6,3i5,a6,2f10.3,a7,2f10.3)
C123456123451234512345123456123456.123123456.1231234567123456.123123456.123
CAAAAAAiiiiiIIIIIiiiiiAAAAAAffffff.fffFFFFFF.FFFAAAAAAAffffff.fffFFFFFF.FFF
C INDE     7    0    0 FOBS=    10.447     0.000 FCALC=    14.371     0.000
C1234567890123456789012345678901234567890123456789012345678901234567890123456
C810   FORMAT(a6,3i5,a6,f10.3,a6,f10.3,a7,2f10.3)
C666666iiiii55555iiiiiAAAAAAffffff.fffAAAAAAffffff.fffAAAAAAffffff.fffFFFFFF.FFF
C1234567890123456789012345678901234567890123456789012345678901234567890123456
C INDE     3    0    0 FOBS=   195.420     0.000 SIGMA=     2.090
C811   FORMAT(a6,3i5,a6,2f10.3,a7,2f10.3)
C1234567890123456789012345678901234567890123456789012345678901234567890123456
C                   FCALC=   534.275   180.000
C812   FORMAT(a25,2f10.3)
C1234567890123456789012345678901234567890123456789012345678901234567890123456
C ++++++++++++++++++ CNS_0.5 reflections file   FORMAT ++++++++++++++++++
C INDE     0    0    2 FOBS=     1.642     0.000 SIGMA=     2.771 TEST=         0
C                   FCALC=  1570.562     0.000 FBULK=  1174.544   180.000
C                   REF_ACTIVE=         1 TST_ACTIVE=         0
810   FORMAT(a6,3i5,a6,2f10.3,a7,f10.3,a6,i10)
811   FORMAT(a25,2f10.3,a7,2f10.3)
812   FORMAT(a30,i10,a12,i10)
C813  The forth line isno longer used in checkversion 0.5 
C ++++++++++++++++++ CNS_0.3 reflections file   FORMAT ++++++++++++++++++
C INDE     0    0    9 FOBS=    70.825     0.000 SIGMA=     0.645 TEST=         0
C                   FCALC=  3903.074     6.216 FBULK=  1809.148   211.960
C                   REF_ACTIVE=         1 TST_ACTIVE=         0
C                   R_SIGMAD=    24.677 R_DD=     0.036
C810   FORMAT(a6,3i5,a6,2f10.3,a7,f10.3,a6,i10)
C811   FORMAT(a25,2f10.3,a7,2f10.3)
C812   FORMAT(a30,i10,a12,i10)
C813   FORMAT(a28,f10.3,a6,f10.3)
C ++++++++++++++++++ CNS reflections file   FORMAT ++++++++++++++++++
C
820   FORMAT(i10)
900   FORMAT(a)
910   FORMAT(1x,a,i10)
911   FORMAT(1x,a,i4,a,i10)
912   FORMAT(1x,a,i4,i4,i4)
920   FORMAT(1x,a,f10.3)
c
C200   FORMAT(3I4,2F8.2)
C201   FORMAT(6x,3i5,7x,f10.3)
c ===================== XPLOR Output   FORMAT  =====================
c250   FORMAT(1x,'INDEx ',3i4,' FOBS=',f10.2,'   SIGMA=',f10.2)
c ===================== CNS Output   FORMAT  =====================
250   FORMAT(' INDEx',3i5,' FOBS=',f10.3,' SIGMA=',f10.3,
     1           ' TEST=',i10)
c ===================== CNS Output   FORMAT with phases  =============
251   FORMAT(' INDEx',3i5,' FOBS=',2f10.3,' SIGMA=',f10.3,
     1           ' TEST=',i10)
c ===================== CNS Output   FORMAT  =====================
c ===================== XtalView PHS   FORMAT  =====================
255   FORMAT(' ', 3i5, 3f10.3 )
c ===================== XtalView PHS   FORMAT  =====================
C NREFlection=     40000
260   FORMAT(' NREFlection=',i10) 
261   FORMAT(' ANOMalous=FALSe { equiv. to HERMitian=TRUE}')
262   FORMAT(' DECLare NAME=FOBS                   
     1DOMAin=RECIprocal   TYPE=COMP END')
263   FORMAT(' DECLare NAME=SIGMA                  
     1DOMAin=RECIprocal   TYPE=REAL END')
264   FORMAT(' DECLare NAME=TEST                   
     1DOMAin=RECIprocal   TYPE=INTE END')

      end
